// Autogenerated AST node
package org.python.antlr.ast;
import org.python.antlr.PythonTree;
import org.antlr.runtime.CommonToken;
import org.antlr.runtime.Token;
import java.io.DataOutputStream;
import java.io.IOException;

public class Call extends exprType {
    public exprType func;
    public exprType[] args;
    public keywordType[] keywords;
    public exprType starargs;
    public exprType kwargs;

    public static final String[] _fields = new String[]
    {"func","args","keywords","starargs","kwargs"};

    public Call(Token token, exprType func, exprType[] args, keywordType[]
    keywords, exprType starargs, exprType kwargs) {
        super(token);
        this.func = func;
        addChild(func);
        this.args = args;
        if (args != null) {
            for(int iargs=0;iargs<args.length;iargs++) {
                addChild(args[iargs]);
            }
        }
        this.keywords = keywords;
        if (keywords != null) {
            for(int ikeywords=0;ikeywords<keywords.length;ikeywords++) {
                addChild(keywords[ikeywords]);
            }
        }
        this.starargs = starargs;
        addChild(starargs);
        this.kwargs = kwargs;
        addChild(kwargs);
    }

    public Call(int ttype, Token token, exprType func, exprType[] args,
    keywordType[] keywords, exprType starargs, exprType kwargs) {
        super(ttype, token);
        this.func = func;
        addChild(func);
        this.args = args;
        if (args != null) {
            for(int iargs=0;iargs<args.length;iargs++) {
                addChild(args[iargs]);
            }
        }
        this.keywords = keywords;
        if (keywords != null) {
            for(int ikeywords=0;ikeywords<keywords.length;ikeywords++) {
                addChild(keywords[ikeywords]);
            }
        }
        this.starargs = starargs;
        addChild(starargs);
        this.kwargs = kwargs;
        addChild(kwargs);
    }

    public Call(PythonTree tree, exprType func, exprType[] args, keywordType[]
    keywords, exprType starargs, exprType kwargs) {
        super(tree);
        this.func = func;
        addChild(func);
        this.args = args;
        if (args != null) {
            for(int iargs=0;iargs<args.length;iargs++) {
                addChild(args[iargs]);
            }
        }
        this.keywords = keywords;
        if (keywords != null) {
            for(int ikeywords=0;ikeywords<keywords.length;ikeywords++) {
                addChild(keywords[ikeywords]);
            }
        }
        this.starargs = starargs;
        addChild(starargs);
        this.kwargs = kwargs;
        addChild(kwargs);
    }

    public String toString() {
        return "Call";
    }

    public String toStringTree() {
        StringBuffer sb = new StringBuffer("Call(");
        sb.append("func=");
        sb.append(dumpThis(func));
        sb.append(",");
        sb.append("args=");
        sb.append(dumpThis(args));
        sb.append(",");
        sb.append("keywords=");
        sb.append(dumpThis(keywords));
        sb.append(",");
        sb.append("starargs=");
        sb.append(dumpThis(starargs));
        sb.append(",");
        sb.append("kwargs=");
        sb.append(dumpThis(kwargs));
        sb.append(",");
        sb.append(")");
        return sb.toString();
    }

    public <R> R accept(VisitorIF<R> visitor) throws Exception {
        return visitor.visitCall(this);
    }

    public void traverse(VisitorIF visitor) throws Exception {
        if (func != null)
            func.accept(visitor);
        if (args != null) {
            for (int i = 0; i < args.length; i++) {
                if (args[i] != null)
                    args[i].accept(visitor);
            }
        }
        if (keywords != null) {
            for (int i = 0; i < keywords.length; i++) {
                if (keywords[i] != null)
                    keywords[i].accept(visitor);
            }
        }
        if (starargs != null)
            starargs.accept(visitor);
        if (kwargs != null)
            kwargs.accept(visitor);
    }

    public int getLineno() {
        return getLine();
    }

    public int getCol_offset() {
        return getCharPositionInLine();
    }

}
